#ifndef BST_H_INCLUDED
#define BST_H_INCLUDED
#include <stdlib.h>
#include <stdio.h>

typedef struct BSTNodeT
{
    void *pData; /**< pointer to data payload */
    struct BSTNodeT *parent; /**< parent node */
    struct BSTNodeT *left; /**< left child */
    struct BSTNodeT *right; /**< right child */
} BSTNodeT;

typedef struct
{
    void *(*extractKey)(void *); /**< pointer to function used to extract key from data */
    int (*compareKeys)(void *, void *); /**< pointer to function used to compare two keys */
    void (*processData)(void *); /**< pointer to function used to print a data element from a node */
    BSTNodeT *root; /**< pointer to root nodde of BST */
} BST;

extern BST *createBST(void *(*extractKey)(void *),  int (*compareKeys)(void *, void *), void (*processData)(void *pData));
extern BSTNodeT *createNode(void *pData);
extern BSTNodeT *insertBST(BST *T, void *pData);
extern BSTNodeT *deleteBST(BST *T, void *pData);
extern BSTNodeT *findBST(BST *T, void *pData);
extern void preBST(BST *T);
extern void postBST(BST *T);
extern void inBST(BST *T);
#endif // BST_H_INCLUDED
