#ifndef BSTTEST_C_INCLUDED
#define BSTTEST_C_INCLUDED
#include <stdio.h>
#include "BST.h"
#include "BSTTest.h"

static int cmpInt(void *k1, void *k2)
{
   return *((int *)k1) - *((int *)k2);
}
static void *extractInt(void *pData)
{
    return (int *)pData;
}
static void printInt(void *pData)
{
    printf ("(%d) ", *((int *)pData));
}

void runBSTTests()
{
    int data[] = {12, 25, 5, 14, 31, 7, 1};
    BST *T1 = createBST(extractInt, cmpInt, printInt);
    if (!T1)
    {
        printf("Cannot create T1. Abort");
        abort();
    }
    preBST(T1);
    for (int i=0; i < (int)(sizeof(data)/sizeof(data[0])); i++)
    {
        insertBST(T1, &data[i] );
        printf("pre:");
        preBST(T1);
        printf("in:");
        inBST(T1);
    }
    int key = 14;
    printf("%d? %sfound\n", key, (findBST(T1, &key)? "" : "NOT "));
    key = 22;
    printf("%d? %sfound\n", key, (findBST(T1, &key)? "" : "NOT "));
    key = 14;
    deleteBST(T1, &key);
    printf("del %d, pre:", key);
    preBST(T1);
    printf("in:");
    inBST(T1);
    key = 12;
    deleteBST(T1, &key);
    printf("del %d, pre:", key);
    preBST(T1);
    printf("in:");
    inBST(T1);
    key = 5;
    deleteBST(T1, &key);
    printf("del %d, pre:", key);
    preBST(T1);
    printf("in:");
    inBST(T1);
}

#endif // BSTTEST_C_INCLUDED
